//==============================================================================
//  Btree.h             Header-Datei zur Klasse Btree:  
//                      Version mit Einfgen und Lschen
//  zuletzt gendert:   01.12.00
//==============================================================================

#include <string.h>
#include <iostream.h>
#include <conio.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>

#define  INFLEN  7           // Lnge der Knoten-Information
#define  NAMLEN  100         // Lnge der Knoten-Information
#define	 nn   3             // Maximalzahl von Items pro Page = Ordnung - 1
#define	 n    2             // Position des nach oben zu verlagernden Items

struct Item
{  int 	 key; 				  // Knoten-Schlssel
   char  info[INFLEN+1];  	  // Knoten-Information
   int   ref;                // Referenznummer
};

struct DPage
{  int numItems; 	           // Anzahl belegter Items
   Item item[nn+1];	        // Item-Liste der DB-Page
};

struct SPage
{  int  FreeRec;            // Anker der Freispeicherliste
   int  AllocRec;           // Anzahl belegter Records in der DB
   int  RootRec;            // Zeiger zur Wurzel
};

struct Buffer               // Puffer fr DB-Pages
{  int  pageNum; 		       // Page-Nummer
   union  {  DPage   dPage; // 1. Alternative: normale Daten-Page
             SPage   sPage; // 2. Alternative: Page 0
          } page;
};

class Btree
{
	public:
      Btree (char *DBname)  { openDatabase(DBname);   }
      virtual ~Btree()      { closeDatabase();        }
	  void 	openDatabase    (char * DBname);
	  void 	closeDatabase   (void);
	  void  insertKey 		 (int key, char * info);
      void  deleteKey       (int delKey);
	  void  printDatabase 	 (void);
	  void  inOrderDatabase  (void);

	   int 	   freeRec;     // Zeiger zum ersten Satz der Freispeicherliste
      int 	   rootRec;     // Index der Baumwurzel
      int 	   allocRec;    // Gre der Datei in Record-Anzahl

      FILE     *DBfile;     // Datenbank-Datei
      Buffer   BF;          // Puffer fr Ein-/Ausgabe von Pages
      Buffer   rootBF;      // Puffer fr Root-Record
      Buffer   Page0BF;     // Puffer fr Page 0

      bool     found;       // globaler Schalter fr Update
      int      risen;       // globaler Schalter fr Update
      int      x;           // globaler Index fr SearchItem und keyTransfer

    private:
	  void  writePage0 		(void);
	  void  allocateRec 	   (int& x);
	  void  savePage 		   (Buffer& BF);
	  void  loadPage 		   (int x);
	  void  searchItem 		(int SearchKey, int& x, bool& found);
	  void  splitPage 		(Buffer& BF, Item& item, int x);
	  void  update 			(int node, int& rise, Item& risenItem, int key, char *data);
      void  copyItem       (Item& ziel, Item quelle);
      void  compensate     (int precedent, int node, int path, bool& underflow);
      void  keyTransfer    (Buffer &BF, int node1, bool& underflow);
      void  delKey         (int node, bool& underflow, int delKey);
      void  releasePage    (int z);
	  void  printDB 		   (int x, int sp);
      void  inOrderDB      (int x, int sp);
};



