#include <stdio.h>
#define N 10                                   /*  Anzahl von Tabellenitems  */
#define LS 6                                   /*    Lnge der Zeichenkette  */
#define LD 20                  /*  Lnge der Zeichenzone fr den Dateinamen  */

typedef struct datensatz {            /*  Struktur Datensatz (Tabellenitem)  */
	  int key;                                   /*  Schlssel           */
	  char name[LS];                             /*  Name (Bezeichnung)  */
	  float gr;                                  /*  Gre               */
	} elem;

/* ------------------------------------------------------------------------- */
/*   Bubble Sort - Sortieren durch lokales Vertauschen - "Zeiger" Variante   */
/* ------------------------------------------------------------------------- */

void BubbleSort (elem *F, int L)
                /*     F  ...  Zeiger auf das zu sortierende Feld von items  */
                /*     L  ...  Zahl von sortierten Feldelementen             */
 {
   elem *H;                          /*  Zeiger auf das zu sortierende Feld  */
   elem Item;                        /*  Zwischenspeicher zum Vertauschen    */
   int  XCHG;                        /*  TRUE, wenn eine Vertauschung vorkam */
                           /*  L ... letzte Position der aktuellen Teilliste */
   do {
     XCHG = 0;             /*  XCHG zeigt an, ob bei dieser Teilliste eine   */
                           /*  Vertauschung vorgenommen werden musste        */
     for (H=F; H<F+L; H++) /* aktuelle Teilliste durchlaufen und vertauschen */
      if (H->key > (H+1)->key)  {
          Item   = *H;                                      /*   Vertausch   */
          *H     = *(H+1);
          *(H+1) = Item;
          XCHG   = 1;     
      }
     L--;
   } while (XCHG);          /* luft solange zwei Elemente vertauscht wurden */
 }


int main()
{
   int  i;                                /*          Indexvariable          */
   char d_name[LD];                       /*    Variable fr den Dateinamen  */
   elem Tab[N], buffer;                   /*       Tabelle, Hilfsbuffer      */
   FILE *f, *fopen();                     /*  Dateivariable, fopen-Prototyp  */

   printf (" Tabellendaten aus Datei einlesen; \n");
   printf ("    Dateinamen eingeben:  ");      
   scanf  ("%s", d_name);                           /*  Dateinamen eingeben  */
   
   if (!(f = fopen(d_name, "r"))) {                        /*  Datei ffnen  */
     printf (" Datei  %s  wurde nicht geffnet ! \n\n", d_name);  
     return (-1);                                                /*  Fehler  */
   }
   i = 0;                                                /*  Daten einlesen  */
   while (fscanf(f,"%d %s %f\n", &Tab[i].key,&Tab[i].name,&Tab[i].gr) != EOF) {
	  i++;                                   
	  printf ("   Der %d. Datensatz wurde eingelesen \n", i);
   }
   printf ("\n");
   fclose(f);                                           /*  Datei schlieen  */

   printf ("\n Kontrollausgabe: \n");                   /*  Kontrollausgabe  */
   for (i=0; i<N; i++) {
     printf ("      %d ", Tab[i].key);
     printf ("    %-6s ", Tab[i].name);
     printf ("%8.2f ",    Tab[i].gr);
     printf ("\n");
   } 

   BubbleSort (Tab, N);
   
   printf ("\n Sortierte Tabelle: \n");  /*  Ausgabe der sortierten Tabelle  */
   for (i=0; i<N; i++) {
     printf ("      %d ", Tab[i].key);
     printf ("    %-6s ", Tab[i].name);
     printf ("%8.2f ",    Tab[i].gr);
     printf ("\n");
   } 

   printf ("\n ***  GOOD BYE !  ***  \n");	
   printf (" Demonstration End \n\n");
   return 0;
}
