
//------------------------------------------------------------------------------
//   sort.cpp:                Sortierverfahren
//   zuletzt geaendert:        20.09.2001/Kp
//------------------------------------------------------------------------------
//  SelectionSort ( int *A, int n);
//  InsertionSort ( int *A, int n);
//  QuickSort     ( int *A, int left, int right);
//  BubbleSort    ( int *A, int n);
//  ShellSort     ( int *A, int n);
//  QuickSort     ( int *A, int left, int right);
//  QuickSortNr   ( int *A, int n);
//  Partition     ( int *A, int left, int right);
//  Sinken        ( int *A, int left, int right);
//  HeapSort      ( int *A, int n);
//  Merge         ( int *A, int *B, int lB, int rB, int *C, int lC, int rC);
//  MergeSort     ( int *A, int left, int right);
//  MergeT        ( int *A, int left, int center, int right);
//  MergeSortBU   ( int *A, int left, int right);
//  RadixSort     ( int *A, int left, int right, int b);
//  Fachverteilen ( int *A, int n);
//------------------------------------------------------------------------------

#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <time.h>
#include <values.h>
#include "stack.cpp"

#define N      10                  // maximale Laenge der Liste
#define KEYLEN 5                   // Laenge der Schluessel beim Fachverteilen

// Globale Variablen
int  A[N+2];                       // zu sortierende Liste
int  B[N+2], C[N+2];               // weitere Hilfsfelder
int  i, j;                         // Laufvariablen

// Prototypen
void SelectionSort (int *A, int n);
void InsertionSort (int *A, int n);
void QuickSort     (int *A, int left, int right);
void BubbleSort    (int *A, int n);
void ShellSort     (int *A, int n);
void QuickSort     (int *A, int left, int right);
void QuickSortNr   (int *A, int n);
int  Partition     (int *A, int left, int right);
void Sinken        ( int *A, int left, int right);
void HeapSort      (int *A, int n);
void Merge         ( int *A,                        // Resultatliste
                     int *B, int lB, int rB,        // 1. Ausgangsliste
                     int *C, int lC, int rC);       // 2. Ausgangsliste
void MergeSort     ( int *A, int left, int right);
void MergeT        ( int *A, int left, int center, int right);
void MergeSortBU   ( int *A, int left, int right);
void RadixSort     (int *A, int left, int right, int b);
void Fachverteilen (int *A, int n);


//------------------------------------------------------------------------------
//                         Sortieren durch Auswaehlen
//------------------------------------------------------------------------------
void SelectionSort (int *A, int n)
{
   int   i, j;                                      // Laufvariablen
   int   min;                                       // Minimum im Restfeld
   int   item;                                      // Hilfsfeld zum Vertauschen zweier Elemente

      for (i=1;i<n;i++)                             // durchlaeuft die zu sortierende Liste
      {
         min = i;                                   // Index des bisher kleinesten Elements
         for (j=i+1;j<=n;j++)                       // Suche, ob noch ein kleineres Element kommt
            if (A[j]<A[min]) min = j;
         item   = A[min];                           // jetzt werden das erste und das kleinste
         A[min] = A[i];                             // Item der Restliste vertauscht
         A[i]   = item;
      }
}

//------------------------------------------------------------------------------
//                        Sortieren durch Einfuegen***
//------------------------------------------------------------------------------
void InsertionSort (int *A, int n)
{
   int   i, j;                                      // Laufvariablen

   for (i=2;i<=n;i++)                               // Schleife ueber alle Restlisten
   {
      // Sichere einzufuegendes Item. A[0] ist gleichzeitig Stopper-Element
      A[0] = A[i];

      // Suche die richtige Einfuegepostion in der sortierten Teilliste
      // Verschiebe dabei die groesseren Items um eine Position nach rechts
      j = i;
      while (A[j-1] > A[0])
      {
         A[j] = A[j-1];
         j--;
      }
      // Fuege das Element A[i] an der richtigen Einfuegeposition ein
      A[j] = A[0];
   }
}

//------------------------------------------------------------------------------
//                            Shell-Sort
//------------------------------------------------------------------------------
void ShellSort (int *A, int n)
{
   int   i, j, h;                                   // Laufvariablen
   int   item;                                      // Hilfsfeld zum Vertauschen zweier Elemente

   for (h=1; h<=n/9; h=3*h+1);                      // h fuer 9 Teillisten einstellen
   for ( ; h>0 ; h /= 3)                            // Schleife ueber die Inkremente h
      for (i=h+1; i<=n ;i+=1)
      {
         item = A[i]; j=i;                          // Teil-Liste mit Insertion Sort sortieren
         while (j>h && A[j-h]>item)
             {A[j] = A[j-h]; j -=h;}
         A[j] = item;
      }
}

//------------------------------------------------------------------------------
//                            Bubble-Sort
//------------------------------------------------------------------------------
void BubbleSort (int *A, int n)
{
   int   i, j;                                      // Laufvariablen
   int   item;                                      // Hilfsfeld zum Vertauschen zweier Elemente
   int   xchg;                                      // Flag = 1    wenn eine Vertauschung vorkam
                                                    // Flag = 0    sonst
   i = n;                                           // i = letzte Position in der Restliste
   do
   {
      xchg = 0;                                     // Flag = 0: bisher noch keine Vertauschung
      for (j=1;j<i;j++)                             // Restliste durchlaufen
      if (A[j]>A[j+1])                              // Nachbarn in die richtige Reihenfolge bringen
      {
         item   = A[j];
         A[j  ] = A[j+1];
         A[j+1] = item;
         xchg   = 1;                                // Flag = 1: es wurde vertauscht !
      }
      i--;
  } while (xchg == 1);                              // wiederhole solange bis im letzten Durchlauf
                                                    // keine Vertauschung mehr aufgetreten ist.
}

//------------------------------------------------------------------------------
//                            Rekursiver Quick-Sort
//------------------------------------------------------------------------------
void QuickSort (int *A, int left, int right)
{
   int   i, j;                                      // Laufvariablen
   int   item;                                      // Hilfsfeld zum Vertauschen zweier Elemente
   int   pivot;                                     // Pivot-Element

   if (right>left)
   {
      pivot = A[right];                             // Pivot-Element festhalten
      i = left-1, j = right;                        // Laufzeiger initialisieren
      for (;;)
      {
         while (A[++i] < pivot);                    // von links  her ein "grosses" El. suchen
         while (A[--j] > pivot);                    // von rechts her ein "kleines" El. suchen
         if (i >= j) break;                         // Abbruch, wenn sich die Zeiger ueberholen
         item = A[i];                               // grosses und kleines Element vertauschen
         A[i] = A[j];
         A[j] = item;
      }
      A[right] = A[i] ;                             // Pivot-Element auf endgueltigen Platz
      A[i] = pivot;
      QuickSort (A,left, i-1  );                    // Teil-Listen getrennt sortieren
      QuickSort (A,i+1,  right);
   }
}

//------------------------------------------------------------------------------
//                     Nichtrekursiver Quick-Sort
//------------------------------------------------------------------------------
void QuickSortNr (int *A, int n)
{
   int  i, left, right;                             // Laufvariablen

   StackInit();                                     // Stack fuer Teil-Listen initialisieren
   left  = 1;                                       // linke  Feldgrenze
   right = n;                                       // rechte Feldgrenze
   A[0]  = -MAXINT;                                 // Stopper-Element auf Position 0 !
   for (;;)
   {
      while (right > left)                          // Abbruchkriterium: Listenlaenge <= 1
       {
          i = Partition (A, left, right);           // Liste in zwei Teile zerlegen
          if (i-left > right-i)
          {
             push(left);  push(i-1);                // groessere Teil-Liste in den Stack
             left = i+1;                            // groessere Teil-Liste in den Stack
          }
          else
          {
             push(i+1);  push(right);               // groessere Teil-Liste in den Stack
             right = i-1;                           // groessere Teil-Liste in den Stack
          }
       }

       if (StackEmpty()) break;                     // fertig !
       right = pop ();                              // naechste Teil-Liste vom Stack holen
       left  = pop ();
   }
}



int  Partition  (int *A, int left, int right)
{
   int  i, j;                                       // Laufvariablen
   int  item;                                       // Hilfsfeld zum Vertauschen zweier Elemente
   int        pivot;                                // Pivot-Element

   pivot = A[right];                                // Pivot-Element festhalten
   i = left-1, j = right;                           // Laufzeiger initialisieren
   for (;;)
   {
      while (A[++i] < pivot);                       // von links  her ein "grosses" El. suchen
      while (A[--j] > pivot);                       // von rechts her ein "kleines" El. suchen
      if (i >= j) break;                            // Abbruch, wenn sich die Zeiger ueberholen
      item = A[i];                                  // grosses und kleines Element vertauschen
      A[i] = A[j];
      A[j] = item;
   }
   A[right] = A[i] ;                                // Pivot-Element auf endgueltigen Platz
   A[i] = pivot;
   return(i);
}

//------------------------------------------------------------------------------
//                              Heap Sort
//------------------------------------------------------------------------------
void Sinken ( int *A, int left, int right )
{
   int  i, j;                                       // Laufzeiger
   int  item;                                       // Hilfsfeld zum Vertauschen zweier Elemente

   i     = left;                                    // zeige zur Wurzel
   j     = 2 * i;                                   // zeige auf den ersten der Soehne
   item = A[i];                                     // sinkendes Item zwischenspeichern

   while ( j <= right )                             // wiederhole Sinken
   {
      if ( j < right )                              // den groesseren der beiden Soehne feststellen
      if ( A[j] < A[j+1] )  j++;
      if ( item >= A[j] )                           // richtiger Platz fuer das Item gefunden: i
      j = right + 1;                                // setze Abbruchbedingung fuer while
      else
      {
         A[i] = A[j];                               // lass Nachfolger aufsteigen
         i = j;                                     // zeige auf naechsten "leeren" Platz
         j = 2 * i;                                 // zeige auf den naechsten Sohn
      }
   }
   A[i] = item;                                     // Trage Item auf dem richtigen Platz ein
}

void HeapSort (int *A, int n)
{        
   int  item;                                       // Hilfsfeld zum Vertauschen zweier Elemente
   int  left, right;                                // linke, rechte Grenze von Teilbaeumen

   left  = ( n / 2 ) + 1;                           // Zeige hinter den untersten Vaterknoten
   right = n;                                       // zeige auf rechtes Listenende
   while ( left > 1 )                               // Schleife zum Aufbau des Heap
   {        left--;                                 // zeige auf den naechsten Vaterknoten
                Sinken (A,left, right);             // lass ihn absinken
   }
   while ( right > 1 )                              // Sortiere jetzt den Heap
   {  item = A[left];                               // tausche Wurzel mit letztem Item
      A[left] = A[right];                           // in der Restliste
      A[right] = item;
      right--;                                      // Restliste verkuerzen
      Sinken (A,left, right);                       // neues Wurzel-Item absinken lassen
   }
}

//------------------------------------------------------------------------------
//                   Merge: Verschmelzen zweier Listen
//------------------------------------------------------------------------------
void Merge ( int *A,                                // Resultatliste
             int *B, int lB, int rB,                // 1. Ausgangsliste
             int *C, int lC, int rC)                // 2. Ausgangsliste
{
   int p, q, r;                                     // Laufzeiger

   p       = lB;                                    // zeige auf erstes Item der Liste A
   q       = lC;                                    // zeige auf erstes Item der Liste B
   B[rB+1] = MAXINT;                                // Stopper-Element fuer Liste A
   C[rC+1] = MAXINT;                                // Stopper-Element fuer Liste B
   
   for (r=1; r <= rB+rC; r++)         // Mischen
      A[r]  = (B[p] < C[q]) ? B[p++] : C[q++];
}


//------------------------------------------------------------------------------
//          MergeSort: Sortieren durch Rekursives Verschmelzen       
//------------------------------------------------------------------------------
void MergeSort ( int *A, int left, int right)
{  int p, q, r, m;                                  // Laufzeiger

   if (right > left)
   {
      m = (right+ left)/2;                          // auf Mitte der Liste zeigen
      MergeSort (A, left, m);                       // linke  Teil-Liste sortieren
      MergeSort (A, m+1, right);                    // rechte Teil-Liste sortieren

      for (p=m+1; p>left;  p--) B[p-1]          = A[p-1];
      for (q=m;   q<right; q++) B[right + m -q] = A[q+1];
      for (r=left; r <=right; r++)
      A[r] = (B[p] < B[q]) ? B[p++] : B[q--];
   }
}


//------------------------------------------------------------------------------
//           MergeT: Verschmelzen zweier Teil-Listen einer Liste
//------------------------------------------------------------------------------
void MergeT ( int *A, int left, int center, int right)
{
   int p, q, i, k;                                  // Laufzeiger
   int AA[N+2];                                     // Hilfsfeld fuer die Ziel-Liste

   p = left;                                        // Zeiger auf 1. Item der linken  Liste
   q = center + 1;                                  // Zeiger auf 1. Item der rechten Liste
   k = left;                                        // Zeiger auf 1. Position der Ziel-Liste
   while ((p<=center) && (q<=right))                // Teil-Listen mischen
   {
      if (A[p] <= A[q])  AA[k++] = A[p++];
      else               AA[k++] = A[q++];
   }
                                                    // Restliste uebernehmen
   if (p > center)  for (i=q; i<= right; i++)   AA[k+i-q] = A[i];
   else             for (i=p; i<= center; i++)  AA[k+i-p] = A[i];
   for (i=left; i<=right; i++) A[i] = AA[i];        // Resultat zurueckspeichern nac A
}


//------------------------------------------------------------------------------
//               MergeSortBU : Bottom-Up Merge Sort
//------------------------------------------------------------------------------
void MergeSortBU ( int *A, int left, int right)
{  
   int p, q, c;                                     // Laufzeiger
   int size;                                        // aktuelle Laenge der Teil-Listen

   size = 1;                                        // mit Teil-Listen der Laenge 1 beginnen
   while (size < right - left +1)                   // solange mind. 2 Teil-Listen vorhanden
   {
      q = left - 1;                                 // Zeiger vor die Gesamtliste stellen
      while (q + size < right)                      // solange es noch mind. 2 Teil-Listen gibt
      {
         p = q+1;                                   // zeige auf naechstes Item der 1. Folge
         c = p + size -1;                           // zeige auf letztes  Item der 1. Folge
         if (c + size <= right)                     // zeige auf rechten  Rand der 2. Folge
            q = c + size;
         else
            q = right;
         MergeT (A,p,c,q);                          // Mische beide Teil-Listen
      }
      size = 2*size;                                // naechst groessere Listenlaenge
   }
}

//------------------------------------------------------------------------------
//                 MergeSortN : Natuerlicher Merge Sort
//------------------------------------------------------------------------------
void MergeSortN ( int *A, int left, int right)
{        
   int p, q, c;                                     // Laufzeiger
   do
   {
      q = left - 1;                                 // q-Zeiger initialisieren
      while (q < right)                             // solange Runs vorhanden sind
      {  p = q + 1;                                 // linker Rand des 1. Run
         c = p;                                     // Stelle Laenge des 1. Run fest
         while ((c < right) && (A[c] <= A[c+1])) c++;
         if (c<right)                               // falls es weitere Items gibt:
         {  q = c+1;                                // linker Rand des 2. Run
            while ((q < right) && (A[q] <= A[q+1])) q++;
               MergeT (A,p,c,q);
         }
         else
            q = c;                                  // keine Elemente mehr fuer den 2. Run
      }
   }  while (p != left);                            // solange wie p noch veraendert wurde
}                                                   // d.h. bis die Gesamtliste ein Run ist


//------------------------------------------------------------------------------
//                               Radix Sort
//------------------------------------------------------------------------------
// Die Funktion Z(k,i) liefert die i-te Ziffer von rechts im Schluessel k

unsigned Z(unsigned k, int i)
{ return (k >> i) & 0x0001;}

void RadixSort (int *A, int left, int right, int b)
{
   int  i, j;                                         // Laufvariablen
   int  item;                                         // Hilfsfeld zum Vertauschen zweier Elemente

   if ((left<right) && (b>=0))                        // solange mindestens 2 Items vorhanden sind
   {                                                  // und die Schluessel-Laenge  b>=0
      i = left; j = right;                            // Laufzeiger initialisieren
      while (i != j)
      {
         while (Z(A[i],b)==0 && (i<j)) i++;           // von links  her "1" suchen
         while (Z(A[j],b)!=0 && (j>i)) j--;           // von rechts her "0" suchen
         item = A[i];                                 // grosses und kleines Element vertauschen
         A[i] = A[j];
         A[j] = item;
      }
      if (Z(A[right],b) == 0) j++;
      RadixSort (A,left, j-1,b-1);                    // Teil-Listen getrennt sortieren
      RadixSort (A,j,  right,b-1);
   }
}


//------------------------------------------------------------------------------
//                       Sortieren durch FAchverteilen
//------------------------------------------------------------------------------
// Die Funktion Z10(k,weight) liefert die Dezimalziffer mit dem Gewicht
// weight im Schluessel k, wobei weight = 1, 10, 100, ....  ist.
unsigned Z10(unsigned k, int weight)
{  int i;
   i = k / weight;

        i =  i - i/10*10;
   return i;
}

void Fachverteilen (int *A, int n)
{
   int   i, j, k;                                     // Laufvariablen
   int   AA[N+2];                                     // Hilfsfeld fuer die Faecher
   int   weight;                                      // Wertigkeit der aktuellen Ziffernposition
   int   F[10];                                       // Zeiger zu den Faechern

   weight = 1;                                        // Gewicht der 1. Ziffernposition
   for (i=0; i < KEYLEN; i++)                         // Schleife ueber die Ziffernpositionen
   {
      for (j=0; j<=9; j++) F[j]=0;                    // Zaehlen, wie oft jede Ziffer vorkommt
      for (j=1; j<=n; j++)
      {
         k = Z10(A[j],weight);
         F[k] = F[k] + 1;
      }

      F[9] = n + 1 - F[9];                            // Anfangspositionen der Faecher bestimmen
      for (j=8; j>=0; j--) F[j] = F[j+1] - F[j];

      for (j=1; j<=n; j++)                            // Verteilphase
      {
         k        = Z10(A[j],weight);
         AA[F[k]] = A[j];
         F[k]     = F[k] + 1;
      }
      for (j=1; j<=n; j++) A[j] = AA[j];              // Sammelphase
      weight = weight*10;                             // Naechstes Zifferngewicht
   }
}


int main(void)
{
   int select;
   cout << "Welches Verfahren wollen Sie testen ?                    \n\n";
   cout << "[ 1]  SelectionSort     Sortieren durch Auswaehlen         \n";
   cout << "[ 2]  InsertionSort     Sortieren durch Einfuegen           \n";
   cout << "[ 3]  ShellSort         Shell-Sort                         \n";
   cout << "[ 4]  BubbleSort        Sortieren durch lokales Vertauschen\n";
   cout << "[ 5]  QuickSort         Rekursives Quicksort-Verfahren     \n";
   cout << "[ 6]  QuickSortNr       Nicht-rekursives Quicksort-Verfahren\n";
   cout << "[ 7]  HeapSort          Heap-Sort-Verfahren                \n";
   cout << "[ 8]  MergeSort         Rekursives Merge Sort-Verfahren    \n";
   cout << "[ 9]  MergeSortBU       Bottom-Up Merge Sort-Verfahren     \n";
   cout << "[10]  MergeSortN        Natuerliches Merge Sort-Verfahren   \n";
   cout << "[11]  RadixSort         Radix Exchange-Sort                \n";
   cout << "[12]  Fachverteilen     Sortieren durch Fachverteilen      \n";
   cout << "[13]  Merge             Verschmelzen von zwei Listen       \n";
   cout << "[14]  MergeT            Verschmelzen von zwei Listen       \n";

   cout << "\nGeben Sie die Auswahlziffer ein:  ";
   cin >> select;

   // Testschleife
   srand(111);
   for (j=1;j<=100;j++)
   {
      // Listen mit Werten zwischen 0 und 100 vorbesetzen und ausgeben
      for(i=1;i<=N;i++)   A[i] = rand() % 100;
      printf("Liste  %i:\nStartliste: ",j);
      for (i=1;i<=N;i++) printf("%3i  ",A[i]);  printf("\n");


      switch (select)
      {
         case 1:   SelectionSort(A, N);break;        // Sortieren durch Auswaehlen
         case 2:   InsertionSort(A, N);break;        // Sortieren durch Einfuegen
         case 3:   ShellSort(A, N);break;            // Shell-Sort
         case 4:   BubbleSort(A, N);break;           // Sortieren durch lokales Vertauschen
         case 5:   QuickSort(A, 1,N);break;          // Rekursives Quicksort-Verfahren
         case 6:   QuickSortNr(A, N);break;          // Nicht-rekursives Quicksort-Verfahren
         case 7:   HeapSort(A, N);break;             // Heap-Sort-Verfahren
         case 8:   MergeSort(A, 1, N);break;         // Rekursives Merge Sort-Verfahren
         case 9:   MergeSortBU(A, 1, N);break;       // Bottom-Up Merge Sort-Verfahren
         case 10:  MergeSortN (A, 1, N);break;       // Natuerliches Merge Sort-Verfahren
         case 11:  RadixSort  (A,1,N,16);break;      // Radix Exchange-Sort
         case 12:  Fachverteilen(A, N);break;        // Sortieren durch Fachverteilen
         case 13:  // Verschmelzen zweier Listen mit Merge
                   for(i=1;i<=N/2;i++)   B[i] = (int) rand()% 100;    // Liste B erzeugen
                   for(i=1;i<=N/2;i++)   C[i] = (int) rand()% 100;    // Liste C erzeugen
                   QuickSort(B, 1,N/2);                               // Ausgangslisten sortieren
                   QuickSort(C, 1,N/2);
                   printf("\nListe  B:   ");                          // Kontrollausgabe
                   for (i=1;i<=N/2;i++) printf("%3i  ",B[i]); printf("\n");
                   printf("Liste  C:   ",j);
                   for (i=1;i<=N/2;i++) printf("%3i  ",C[i]); printf("\n");
                   Merge (A, B, 1, N/2, C, 1, N/2);                   // Verschmelzen
                   break;
         case 14:  // Verschmelzen zweier Teil-Listen mit MergeT
                   QuickSort(A, 1,N/2);                               // Teillisten sortieren
                   QuickSort(A, N/2+1,N);
                   printf("sortierte \nTeillisten: ",j);
                   for (i=1;i<=N;i++) printf("%3i  ",A[i]);  printf("\n");
                   MergeT (A, 1, N/2,N);                              // Verschmelzen
                   break;
         default:  cout << "Falsche Auswahlziffer !\n";
      }

      // sortierte Liste ausgeben
      printf("Ergebnis:   ");
      for (i=1;i<=N;i++)  printf("%3i  ",A[i]);  printf("\n\n");

      // Sortierung kontrollieren
      for (i=1;i<N;i++)
         if (!(A[i] <= A[i+1]))
         {
            printf("Error detected");
            exit(-1);
         }
      getch();
   }
   return(0);
}
