//------------------------------------------------------------------------------
//   Testrahmen zu den Hash-Algorithmen (Lsung)
//   zuletzt gendert am:   10.12.01/Kp
//------------------------------------------------------------------------------

#include <fstream.h>
#include <conio.h>
#include <iomanip.h>
#include <values.h>
#include "hash.h"

//---------------------------------------------------------------------------
const unsigned LINELEN = 40;

//------------------------------------------------------------------------------
//  weiter  -  Wartet Eingabe von ENTER ab, ignoriert alles andere
//------------------------------------------------------------------------------
void weiter(void)
{
    cout << "\n                  <ENTER>";  // Prompt ausgeben
    cin.ignore (MAXINT, '\n');             // alles bis ENTER ignorieren
    clrscr();                               // Screen lschen
}

//------------------------------------------------------------------------------
// getInputFile:  Erfragt Namen der Eingabedatei und ffnet sie
//------------------------------------------------------------------------------
void getInputFile (char *inFile, fstream& f)
{
    bool ok;
	do
	{
      ok=true;
      cout << endl << "Bitte Name der Eingabedatei eingeben:   ";
      cin.getline (inFile, LINELEN);
      f.open (inFile, ios::in);
      if (!f)
      { cout << "Eingabedatei kann nicht geffnet werden !" << endl;
   		ok = false;
      }
    } while (!ok);
}


void main()
{
    int      index, found;
    Item     item0;
    HTable   A, B;
    unsigned int NewKey;
    char     stringKey[LINELEN];
    fstream  fin;								 // Eingabedatei fr Textsuche
    char     inFile[80];                		 // Name der Eingabedatei

    do // Umwandlung nichtnumerischer Schlssel in numerische Schlssel
    {
      cout << "\nString-Schluessel konvertieren (Nur Buchstaben, Abbruch=#)     : ";
      cin  >> stringKey;
      NewKey = A.numericKey (stringKey);
      if (NewKey==0)  break;
      cout  << "Der numerische Wert des Schlussels \"" << stringKey << "\" ist: "
            << NewKey << endl;
    }  while (true);

    do  //	Hash-Tabelle durch Einfgen von Items aufbauen
    {
      cout << "\nWelchen Schluessel wollen Sie einfuegen (Abbruch=#) ?      : ";
      cin  >> stringKey;
      NewKey = A.numericKey (stringKey);         // Schlssel vorbereiten
      if (NewKey==0)  break;
      item0.key = NewKey;
      strcpy (item0.data, stringKey);
      A.InsertItem (item0);						 // Item in die Hashtabelle
      A.PrintHtable();							 // Tabelle zur Kontrolle ausgeben
    }  while (true);

    do // Items in der Hash-Tabelle suchen
    {
      cout << "\nWelchen Schluessel wollen Sie suchen (Abbruch=#) ?         : ";
      cin  >> stringKey;
      NewKey = A.numericKey (stringKey);         // Schlssel vorbereiten
      if (NewKey==0)  break;
      A.HSearch (NewKey, index, found);          // Item suchen
      if (found==true)                           // Suchergebnis ausgeben
        cout << "Der Schluessel \"" << stringKey << "\" wurde auf Position "
             << index << " gefunden\n\n";
      else
        cout << "Der Schluessel \"" << stringKey << "\" wurde nicht gefunden\n\n";
    }  while (true);

    do //	Items aus der Hash-Tabelle lschen
    {
      cout << "\nWelchen Schluessel wollen Sie loeschen (Abbruch=#) ?       : ";
      cin >> stringKey;
      NewKey = A.numericKey (stringKey);         // Schlssel vorbereiten
      if (NewKey==0)  break;
      A.DeleteItem (NewKey);        			   // Item lschen
      A.PrintHtable();							      // Tabelle zur Kontrolle ausgeben
    }  while (true);

    // C-Keywords von Datei einlesen und Hashtabelle aufbauen
    //-------------------------------------------------------
    cin.ignore (MAXINT, '\n');               	 // Eingabepuffer leeren
    getInputFile  (inFile, fin);              	 // Eingabedatei ffnen
    fin.getline(stringKey, 20);               	 // erste Zeile aus der Datei lesen
    NewKey = B.numericKey (stringKey);        	 // Schlssel vorbereiten
    if (NewKey==0)  return;
    item0.key = NewKey;
    strcpy (item0.data, stringKey);
    B.InsertItem (item0);						       // Erstes Item in die Hashtabelle
    while (!fin.eof())
    {
      fin.getline(stringKey, LINELEN);       	 // naechste Zeile lesen
      NewKey = B.numericKey (stringKey);     	 // Schlssel vorbereiten
      if (NewKey==0)  break;
      item0.key = NewKey;
      strcpy (item0.data, stringKey);
      B.InsertItem (item0);						    // Item in die Hashtabelle
    }
    fin.close();
    B.PrintHtable();							          // Tabelle zur Kontrolle ausgeben
    weiter();
    return;
}
