#include <stdio.h>
#define N 10                           /*  Anzahl von Tabellenitems  */
#define LS 20                          /*    Lnge der Zeichenkette  */
#define LD 30          /*  Lnge der Zeichenzone fr den Dateinamen  */ 

typedef struct dat_satz {     /*  Struktur Datensatz (Tabellenitem)  */
	  int num;                           /*    Schlssel         */
	  char name[LS];                     /*    Warenname         */
	  float e_preis;                     /*    Einzelpreis       */
	  int anzahl;                        /*    Stck             */
	  float ges_preis;                   /*    Gesamtpreis       */
	} item;

int seq_search (int key, item *t, item *result, int p)
   /*  Funktion  seq_search  fr sequentielle Suche in der Tabelle  t */
   /*  Parameter:  key    - Schlssel der gesuchten Ware, 
                   t      - Name der durchgesuchten Tabelle, 
                   result - Zeiger auf die Speicherzone, auf die das
                            gesuchte Item abgespeichert werden soll
                   p      - Lnge der Tabelle                        */
   /*  Funktionswert:   0, wenn das Item erfolgreich gefunden war,
                       -1, wenn das Item nicht gefunden war          */
{
   int i;                                  /*  Variable fr Indizes  */

   for (i=0; i<p; i++) 
     if (t[i].num == key) {
                 *result = t[i];                  /*  Item gefunden  */
                 return (0);
     }
     return (-1);                           /*  Item nicht gefunden  */
}
      
int main()
{
   int  i, m, schluessel;         /*  Indexvariable, Warenschlssel  */
   char d_name[LD];               /*    Variable fr den Dateinamen  */
   item tab[N], buffer;           /*           Tabelle, Hilfsbuffer  */
   FILE *f, *fopen();             /*  Dateivariable, fopen-Prototyp  */

   printf (" Tabellendaten aus Datei einlesen; \n");
   printf ("    Dateinamen eingeben:  ");      
   scanf  ("%s", d_name);                   /*  Dateinamen eingeben  */
   
   if (!(f = fopen(d_name, "r"))) {                /*  Datei ffnen  */
     printf (" Datei  %s  wurde nicht geffnet ! \n\n", d_name);  
     return (-1);                                        /*  Fehler  */
   }
   i = m = 0;                                    /*  Daten einlesen  */
   while (fscanf (f,"%d %s %f %d %f\n", &tab[i].num, &tab[i].name,
	   &tab[i].e_preis, &tab[i].anzahl, &tab[i].ges_preis) != EOF) {
	  i++; m++;                                 
	  printf ("   Der %d. Datensatz wurde eingelesen \n", i);
   }
   printf ("\n");
   fclose(f);                                   /*  Datei schlieen  */

   printf ("\n Kontrollausgabe: \n");           /*  Kontrollausgabe  */
   for (i=0; i<m; i++) {
     printf ("     %d ", tab[i].num);
     printf ("  %-20s ", tab[i].name);
     printf ("  %8.2f ", tab[i].e_preis);
     printf ("  %5d ", tab[i].anzahl);
     printf ("  %8.2f", tab[i].ges_preis);
     printf ("\n");
   } 

   schluessel = 99;
   while (schluessel != 0) {                /*  Suche demonstrieren  */
     printf ("\n Schlssel (1..99) eingeben:  ")   ;
     scanf ("%d", &schluessel);
     if (schluessel == 0) break;
     if (!seq_search (schluessel, tab, &buffer, m)) {
       printf ("\n Gefundenes Item: \n");    /*  erfolgreiche Suche  */
       printf ("     %d ", buffer.num);
       printf ("  %20s ", buffer.name);
       printf ("  %8.2f ", buffer.e_preis);
       printf ("  %5d ", buffer.anzahl);
       printf ("  %8.2f", buffer.ges_preis);
       printf ("\n");
     } else
       printf ("\n Item mit Schlssel  %d  wurde nicht gefunden \n", schluessel);
     printf("\n");                         /*  unerfolgreiche Suche  */
   }
   
   printf ("\n ***  GOOD BYE !  ***  \n");	
   printf (" Demonstration End \n\n");
   return 0;
}
